<template>
  <div>
    <gz-report-selector ref="reportSelector"></gz-report-selector>
    <gz-extensions
      ref="extensions"
      :aya-type="aType"
      :selected-items="selectedItems"
    >
    </gz-extensions>
    <gz-data-table
      ref="gzdatatable"
      form-key="reminder-list"
      data-list-key="ReminderDataList"
      :show-select="rights.read"
      :reload="reload"
      data-cy="remindersTable"
      @selection-change="handleSelected"
    >
    </gz-data-table>
  </div>
</template>
<script>
const FORM_KEY = "reminder-list";
export default {
  data() {
    return {
      rights: window.$gz.role.defaultRightsObject(),
      aType: window.$gz.type.Reminder,
      selectedItems: [],
      reload: false
    };
  },
  created() {
    this.rights = window.$gz.role.getRights(window.$gz.type.Reminder);
    window.$gz.eventBus.$on("menu-click", clickHandler);
    generateMenu(this);
  },
  beforeDestroy() {
    window.$gz.eventBus.$off("menu-click", clickHandler);
  },
  methods: {
    handleSelected(selected) {
      this.selectedItems = selected;
    }
  }
};

/////////////////////////////
//
//
async function clickHandler(menuItem) {
  if (!menuItem) {
    return;
  }
  const m = window.$gz.menu.parseMenuItem(menuItem);
  if (m.owner == FORM_KEY && !m.disabled) {
    switch (m.key) {
      case "new":
        m.vm.$router.push({
          name: "reminder-edit",
          params: { recordid: 0 }
        });
        break;
      case "extensions":
        {
          const res = await m.vm.$refs.extensions.open(
            m.vm.$refs.gzdatatable.getDataListSelection(
              window.$gz.type.Reminder
            )
          );
          if (res && res.refresh == true) {
            m.vm.reload = !m.vm.reload;
          }
        }
        break;
      case "report":
        {
          const res = await m.vm.$refs.reportSelector.open(
            m.vm.$refs.gzdatatable.getDataListSelection(
              window.$gz.type.Reminder
            ),
            m.id
          );
          if (res == null) {
            return;
          }
          window.$gz.form.setLastReportMenuItem(FORM_KEY, res, m.vm);
        }
        break;
      default:
        window.$gz.eventBus.$emit(
          "notify-warning",
          FORM_KEY + "::context click: [" + m.key + "]"
        );
    }
  }
}

//////////////////////
//
//
function generateMenu(vm) {
  const menuOptions = {
    isMain: true,
    icon: "$sockiStickyNote",
    title: "ReminderList",
    helpUrl: "home-reminders",
    menuItems: [],
    formData: {
      sockType: window.$gz.type.Reminder
    }
  };

  if (vm.rights.change) {
    menuOptions.menuItems.push({
      title: "New",
      icon: "$sockiPlus",
      surface: true,
      key: FORM_KEY + ":new",
      vm: vm
    });
  }

  menuOptions.menuItems.push({
    title: "Report",
    icon: "$sockiFileAlt",
    key: FORM_KEY + ":report",
    vm: vm
  });

  const lastReport = window.$gz.form.getLastReport(FORM_KEY);
  if (lastReport != null) {
    menuOptions.menuItems.push({
      title: lastReport.name,
      notrans: true,
      icon: "$sockiFileAlt",
      key: FORM_KEY + ":report:" + lastReport.id,
      vm: vm
    });
  }

  menuOptions.menuItems.push({
    title: "Extensions",
    icon: "$sockiPuzzlePiece",
    key: FORM_KEY + ":extensions",
    vm: vm
  });
  window.$gz.eventBus.$emit("menu-change", menuOptions);
}
</script>
